﻿$replaceHash = @{ "^ " = "++space++" # leading space in filename
                  "\\ " = "\++space++" # leading space in filename in subfolder
                  " $" = "++space++" # trailing space in filename
                  " \\" = "\++space++" #trailing space in filename in subfolder
                  "\\" = "++backslash++"
                  "\/" = "++slash++"
                  ":" = "++colon++"
                  "\*" = "++asterisk++"
                  "\?" = "++question++"
                  '\"' = "++doublequote++"
                  "<" = "++lessthan++"
                  ">" = "++greaterthan++"
                  "\|" = "++pipe++"
                  "" = "++unknown++"
}

$illegalNamesPrefix = 'x'
$illegalNamesList = [System.Collections.ArrayList]@( "CON", "PRN", "AUX", "NUL" )
foreach ($x in 0..9) {
    $temp = $illegalNamesList.Add("COM$x")
    $temp = $illegalNamesList.Add("LPT$x")
}

$dorename = 0
$path = $args[0]
if ($path -eq "dorename") {
    $dorename = 1
    $path = $args[1]
}

# Create regex for finding "bad" characters
$replaceList = $replaceHash.keys -join '|'

$fileList = @(Get-ChildItem -Recurse $path)

foreach ($file in $fileList) {
    if ($illegalNamesList -contains $file.Name) {
        $newName = $illegalNamesPrefix + $file.Name
        Write-Output "'$($file.FullName)' -----> '$newName'."
        if ($dorename) {
            Rename-Item -Path $($file.FullName) -NewName $newName
        }
    }
    elseif ($file.Name -match $replaceList) {
        $newName = $file
        foreach ($key in $replaceHash.keys) {
            if ($file.Name -match $key) {
                $newName = $newName -replace $key, $replaceHash.$key
            }
        }
        Write-Output "'$($file.FullName)' -----> '$newName'."
        if ($dorename) {
            Rename-Item -Path $($file.FullName) -NewName $newName
        }
    }
}